-- CCFocusForm functions

CCFocusFormTemp = {}

function CCFocusForm_OnAccept()
  if CCFocusFormTemp.clear then
    CCFocus_SetKey("clear", CCFocusFormTemp.clear, 0)
    CCFocusFormTemp.clear = nil
  end
  if CCFocusFormTemp.set then
    CCFocus_SetKey("set", CCFocusFormTemp.set, 0)
    CCFocusFormTemp.set = nil
  end
  if CCFocusFormTemp.icon then
    CCFocus_MakeRaidMacro(CCFocusFormTemp.icon)
    CCFocusFormTemp.icon = nil
  end
end

function CCFocusForm_OnLoad(panel)
  -- do localization if needed
  if ( CCFocus_FormLocalized ) then
    CCFocusFormClearLabel:SetText(CCFocus_Strings.FormClearLabel);
    CCFocusFormSetLabel:SetText(CCFocus_Strings.FormSetLabel);
    CCFocusFormDone:SetText(CCFocus_Strings.FormDone);
    CCFocusFormRaidIconsLabel:SetText(CCFocus_Strings.RaidIcons);
  end
  panel.name = "CCFocus"
  panel.okay = CCFocusForm_OnAccept
  -- if they cancel, there's nothing to do
  panel.cancel = nil
  InterfaceOptions_AddCategory(panel)
end

function CCFocusForm_SetIconButtonState(which, state)
  -- using the "lock" option, since these should act like radio buttons
  getglobal("CCFocusFormIconButton"..which):SetButtonState(state, 1);
end

function CCFocusForm_OnShow()
  CCFocusFormTemp.set = CCFocus_Options.SetKey
  CCFocusFormTemp.clear = CCFocus_Options.ClearKey
  CCFocusFormSetFocusText:SetText(CCFocusFormTemp.set)
  CCFocusFormClearFocusText:SetText(CCFocusFormTemp.clear)
  CCFocusFormTemp.icon = CCFocus_RaidIcon
  CCFocusForm_SetIconButtonState(CCFocusFormTemp.icon, "PUSHED")
end

function CCFocusForm_IconSelect(which)
  -- first, unpush the old button
  CCFocusForm_SetIconButtonState(CCFocusFormTemp.icon, "NORMAL");

  -- MakeRaidMacro sets CCFocus_RaidIcon for us
  -- CCFocus_MakeRaidMacro(which);
  -- set the new raid icon
  CCFocusFormTemp.icon = which;
  -- then, push the new one
  CCFocusForm_SetIconButtonState(CCFocusFormTemp.icon, "PUSHED");
end

local clear_menu = CreateFrame("Frame", "CCFocusFormClearMenu")

CCFocusForm_clear_menulist = {
  { text = "shift", func = function() 
     CCFocusFormTemp.clear = "shift" 
     UIDropDownMenu_SetSelectedID(CCFocusFormClearFocus, this:GetID(), 0)
  end },
  { text = "alt", func = function() 
    CCFocusFormTemp.clear = "alt" 
    UIDropDownMenu_SetSelectedID(CCFocusFormClearFocus, this:GetID(), 0)
  end },
  { text = "ctrl", func = function() 
    CCFocusFormTemp.clear = "ctrl"
    UIDropDownMenu_SetSelectedID(CCFocusFormClearFocus, this:GetID(), 0)
  end }
}

local set_menu = CreateFrame("Frame", "CCFocusFormSetMenu")

CCFocusForm_set_menulist = {
  { text = "shift", func = function() 
     CCFocusFormTemp.set = "shift" 
     UIDropDownMenu_SetSelectedID(CCFocusFormSetFocus, this:GetID(), 0)
  end },
  { text = "alt", func = function() 
    CCFocusFormTemp.set = "alt" 
    UIDropDownMenu_SetSelectedID(CCFocusFormSetFocus, this:GetID(), 0)
  end },
  { text = "ctrl", func = function() 
    CCFocusFormTemp.set = "ctrl"
    UIDropDownMenu_SetSelectedID(CCFocusFormSetFocus, this:GetID(), 0)
  end }
}
